;***********ToyStory, by VirginMarie
;see https://www.loverslab.com/files/file/16092-toys/
Scriptname TStoryMain extends Quest Conditional
{Toy Story is a Toys content mod. Purpose: 1) end user tutorial 2) test harness 3) demo and examples for mod authors}
ToysFramework Property Toys Auto
;/
- Currently its complete in terms of demoing each Toy Handling API, through the MCM, but the quest is far from complete
- API functions called are in ToysFramework.psc. See API documentation there
/;
;========== Cloned/Customized Toys ==========
;============================================
Armor Property ScantyBelt Auto ;Curio
Armor Property AnalPlug Auto ;Curio
Armor Property WristCuffs Auto ;Curio
Armor Property ScantyBeltRest Auto ;Restored
Armor Property AnalPlugRest Auto ;Restored
Armor Property WristCuffsRest Auto ;Restored
Armor Property NippleT Auto ;Nightly

;/========== Story Demos ==========
===================================
- Functions calling Toys API (usually through the wrapper functions below), used during quests and referenced by Dev Tips
- 'Dev Tips' are messages in game during quest, which can be turned on/off in the MCM (off by default)
/;

;.....Demo 1..... Book read triggers toys equipped, playing nice
;check for available Pelvis and Anal Slots
;proceed to equip if slots available
;otherwise quest goes on hold until blocking toys removed
Function TStoryBook()
	TStoryLog("Book READ")
	TStoryDevTip("DEMO 1. Book read triggers toys equipped, playing nice.")
	If ! TStorySlotAvailable(7) || ! TStorySlotAvailable(6)  || ! TStorySlotAvailable(15)
		TStoryTip("Cannot proceed. Your chastity, arm, or anal toy cannot be removed. Once you have managed to remove them, read the book again to proceed.")
		Return
	EndIf
	If TStoryHandleToy(ScantyBelt) && TStoryHandleToy(AnalPlug) && TStoryHandleToy(WristCuffs)
		TStorysStrip()
		TStoryNotify("3 toys latched onto you!")
		ToyStory.SetObjectiveCompleted(20)
		ToyStory.SetStage(30)
		ToyStory.SetObjectiveDisplayed(30)
	Else 
		;do nothing, this would be very rare
	EndIf	
EndFunction

;.....Demo 2..... Hide selected toys during a love scene
;hide animation inappropriate toys during the scene. IMPORTANT: must UnHideToys() when scene ends
Function TStoryStoreOnStone()
	TStoryHideToys()
	TStoryLog("Hide toys for Phasing Stone love scene")
EndFunction

;.....Demo 3..... Reserve Slots & Store all player's toys for a long scene
;reserve slots during the scene (stops other mods from equipping during the scene)
;put all worn toys, if permitted, into virtual storage for scene
Function TStoryStoreOnEntry()
	TStorysStrip()
	TStoryDevTip("DEMO 3. Reserve Slots & Store all player's toys for a long scene.")
	If Toys.ReserveSlots("TStory")
		If TStoryUnequipToys(Toys.ToysToy, Store=True)
			TStoryNotify("Toys worn placed in chest")
			TStoryLog("Toys worn placed in chest")
		Else
			;do nothing, its fine if none to store
		EndIf	
	Else
		;this sould be rare as player cannot be in another mod's scene
		TStoryNotify("Can't store toys, proceeding without")
		TStoryLog("Can't store toys, proceeding without")
	EndIf
EndFunction

;.....Demo 4..... Un-Store some of the toys, mid scene
;Un-store specific toys, leaving the rest still stored during the scene. Swaps them out with new variants
;uses the destroy parm so they are not left in inventory
;IMPORTANT: must unreserve/un-store when scene ends. A one liner "TStoryReserveSlots(False)" in scene end
Function TStoryUnStoreCurio()
	TStorysStrip()
	TStoryDevTip("DEMO 4. Un-Store some of the toys, mid scene")
	TStoryUnStoreToys(ScantyBelt) && TStoryUnStoreToys(AnalPlug) && TStoryUnStoreToys(WristCuffs)
	;not checking for success, a fail here would be very rare and we can continue
	Utility.WaitMenuMode(0.5)
	TStoryHandleToy(ScantyBeltRest, Destroy=True)
	TStoryHandleToy(AnalPlugRest, Destroy=True)
	TStoryHandleToy(WristCuffsRest, Destroy=True)
	TStoryNotify("Curio toys reequipped")
	TStoryLog("Curio toys reequipped")
EndFunction

;.....Demo 5..... Semi-random Equip NPC
;Equip Nightly randomly from Classic Toy Box, the first time. Randomly change her up each time she appears thereafter
;This will fall back to a random Toy Box if the Classic Toy Box is not installed
Function TStoryEquipNightly()
	If ToyStory.GetStage() == 60
		TStoryLog("Equip Classic toys on Nightly if possible, otherwise from random box")
		TStoryEquipNPC(Toys.GetToy("TStory", 4, "Classic", Available=False, Prefer=False))  ;neck
		TStoryEquipNPC(Toys.GetToy("TStory", 7, "Classic", Available=False, Prefer=False))  ;pelvis
		TStoryEquipNPC(Toys.GetToy("TStory", 9, "Classic", Available=False, Prefer=False))  ;nipples
		TStoryEquipNPC(Toys.GetToy("TStory", 10, "Classic", Available=False, Prefer=False)) ;legs
		TStoryEquipNPC(Toys.GetToy("TStory", 14, "Classic", Available=False, Prefer=False)) ;torso 
		TStoryEquipNPC(Toys.GetToy("TStory", 15, "Classic", Available=False, Prefer=False)) ;arms
	Else
		TStoryLog("Equip random toys on Nightly")
		Nightly.RemoveAllItems()
		TStoryEquipNPC(Toys.GetToy("TStory", 4, Available=False, Prefer=False))  ;neck
		TStoryEquipNPC(Toys.GetToy("TStory", 6, Available=False, Prefer=False))  ;anal
		TStoryEquipNPC(Toys.GetToy("TStory", 7, Available=False, Prefer=False))  ;pelvis
		TStoryEquipNPC(Toys.GetToy("TStory", 9, Available=False, Prefer=False))  ;nipples
		TStoryEquipNPC(Toys.GetToy("TStory", 10, Available=False, Prefer=False)) ;legs
		TStoryEquipNPC(Toys.GetToy("TStory", 14, Available=False, Prefer=False)) ;torso 
		TStoryEquipNPC(Toys.GetToy("TStory", 15, Available=False, Prefer=False)) ;arms
	EndIf
EndFunction
Function TStoryEquipNPC(Armor Toy)
	If Toy
		Nightly.EquipItem(Toy, True, True) ;tag not using HandleToy() for now. Might make HandleToy() provide benefits later
	EndIf
EndFunction

;/========== Wrappers  Calling Toys API ==========
;=================================================
- Feel free to copy and adapt these wrapper functions in your own mod. Be sure to replace "TStory" with your own mod name


;.......... Handle Toy... Calls Toys.HandleToy()
- equips or unequips the player, including swapping, playing nice with other mods, and dealing with failure return codes

Returns from Toys.HandleToy() for failure:
0 = = Toy unequip or store called for but toy not worn
-1 = Invalid Toy, Actor, ShortModName, Actor is not player and using store, or Store in use without reserving slots
-2 = Swap/unequip/store not possible. Toy present is from another mod, with restrictive keyword, or from DD
-3 = Equip not possible. Slots are reserved by another mod
-9 = mutex wait timeout

This function returns false for any negative above, and logs the error. True if success. 0 (toy not worn) is treated as success
/;
Bool Function TStoryHandleToy(Armor Toy, Bool UnEquipToy=False, Bool Store=False, Bool Destroy=False)
	If ! Toy
		Return False
	EndIf
	Int RetCode
	RetCode = Toys.HandleToy("TStory", PlayerRef, Toy, UnEquipToy, Store, Destroy)
	If RetCode < 0
		If Toy
			TStoryLog("Equip/unequip of " + Toy.GetName() + " failed")
		EndIf
		Count = 0
		While RetCode == -9
			TStoryLog("Failed due to Toys Mutex. Trying again")
			Count += 1
			If Count > 2
				TStoryLog("ERROR: Retry timeout. Aborting", True)
				Return False
			EndIf
			Utility.WaitMenuMode(1)
			RetCode = Toys.HandleToy("TStory", PlayerRef, Toy, UnEquipToy, Store, Destroy)
		EndWhile
		If RetCode == -1
			TStoryLog("ERROR: invalid/incompatible Toy, or Actor, or invalid use of store", True)
			Return False
		ElseIf RetCode == -2 
			TStoryLog("Toy with restrictive keyword from another mod, or from DD, is present", True)
			Return False
		ElseIf RetCode == -3
			TStoryLog("Slots are reseved by another mod", True)
			Return False
		EndIf
		Return True
	EndIf
	Return True
EndFunction

;/.......... Unequip Toys... Calls Toys.UnequipToys()
- unequips toys worn on Player using keywords, playing nice with other mods, and dealing with return codes
- optonally uses the temporary storage feature

Returns from UnequipToys() for success:
X = total number of toys unequipped or stored successfully
Returns from UnequipToys() for failure:
-1 = Invalid ShortModName, Actor, or missing IncludeKeyword. If using Store the actor must be the player
-2 = can't use 'Store' without first Reserving Slots. See ReserveSlots()
-9 = mutex wait timeout

This function returns false for any of the above, and logs the error. True if success, including 0 items found
/;
Bool Function TStoryUnequipToys(Keyword IncludeKeyword, Keyword ExcludeKeyword=none, Bool Store=False, Bool Destroy=False)
	Int RetCode
	RetCode = Toys.UnequipToys("TStory", PlayerRef, IncludeKeyword, ExcludeKeyword, Store, Destroy)
	If RetCode < 0
		TStoryLog("Unequip by keyword failed")
		Count = 0
		While RetCode == -9
			TStoryLog("Failed due to Toys Mutex. Trying again")
			Count += 1
			If Count > 2
				TStoryLog("ERROR: Retry timeout. Aborting", True)
				Return False
			EndIf
			Utility.WaitMenuMode(1)
			RetCode = Toys.UnequipToys("TStory", PlayerRef, IncludeKeyword, ExcludeKeyword, Store, Destroy)
		EndWhile
		If RetCode == -1 || RetCode == -2
			TStoryLog("ERROR: invalid Actor, missing IncludeKeyword, or slots reserved by another mod ", True)
			Return False
		EndIf
		Return True
	EndIf
	Return True
EndFunction

;.......... HideToys & UnHideToys
;- Temporarily hide toys for a short scene
Function TStoryHideToys(Bool Wrists=True, Bool Pelvis=True, Bool Mouth=True, Bool Anal=True, Bool Vaginal=True, Bool Torso=True, Bool Feet=True)
	Toys.HideToys("TStory", Wrists, Pelvis, Mouth, Anal, Vaginal, Torso, Feet)
EndFunction
Function TStoryUnHideToys()
	Toys.UnHideToys("TStory")
EndFunction

;/.......... UnStore Toys... Calls Toys.UnStoreToys()
- Re-equip all toys previously stored

Returns from UnStoreToys() for success:
x = total number of toys unStored successfully
Returns for failure:
-1 = Nothing in storage to un-Store
-2 = Slots reserved by another mod
-9 = mutex wait timeout

This function returns false for any negative above, and logs the error. True if success, including 0 items found
/;
Bool Function TStoryUnStoreToys(Armor Toy=None)
	Int RetCode
	RetCode = Toys.UnStoreToys("TStory", Toy)
	If RetCode < 0
		TStoryLog("UnStore failed")
		Count = 0
		While RetCode == -9
			TStoryLog("Failed due to Toys Mutex. Trying again")
			Count += 1
			If Count > 2
				TStoryLog("ERROR: Retry timeout. Aborting", True)
				Return False
			EndIf
			Utility.WaitMenuMode(1)
			RetCode = Toys.UnStoreToys("TStory")
		EndWhile
		If RetCode == -1 || RetCode == -2
			TStoryLog("ERROR: nothing in storage or slots reserved by another mod", True)
			Return False
		EndIf
		Return True
	EndIf
	Return True
EndFunction

;/.......... Reserve Slots ... Calls Toys.ReserveSlots()
- Temporarily reserves open toy slots for use by only your mod. This prevents another mod from equipping toys during your scene

ReserveSlots() Returns True if:
- Reserving or un-resevering was successful
- your mod has already got the reservation
ReserveSlots() Returns False if:
- Reserved by another mod

This function returns false for any negative above, and logs the error. True if success, including 0 items found
/;
Bool Function TStoryReserveSlots(Bool Reserve = True)
	Return Toys.ReserveSlots("TStory", Reserve)
EndFunction

;/.......... Is Slot Available... Calls Toys.IsSlotAvailable()
- Is slot available, based on method of unequip (IfUseStore)

SlotAvailable() Returns True if:
= Slot is empty, or toy that occupies it has no restrictions, or the player equipped (in which case restrictions are ignored)
SlotAvailable() Returns False if:
- Invalid ToyType
- when IfUseStore False, an occupying toy from another mod has a restrictive keyword
- when IfUseStore True, an occupying toy from another mod has the 'NoRemoval' keyword
= Mutex wait timeout

This function returns exactly as SlotAvailable() above
/;
Bool Function TStorySlotAvailable(Int ToyType, Bool IfUseStore=False)
	Return Toys.IsSlotAvailable("TStory", ToyType, IfUseStore)
EndFunction


;========== MCM Tests ==========
;===============================

;.......... GetToy() & HandleToy() - Equip random pelvis from any box
Function TStoryTest1()
	TStoryLog("TESTING GetToy() & HandleToy() Equip random pelvis from any box ")
	If TStoryHandleToy(Toys.GetToy("TStory", 7))
		Debug.MessageBox("Success: Equip random pelvis from any box")
	Else
		Debug.MessageBox("Fail: Equip random pelvis - see log")
	EndIf
EndFunction

;.......... UnequipToys() - Unequip pelvis
Function TStoryTest2()
	TStoryLog("TESTING HandleToy() Unequip pelvis")
	If TStoryUnequipToys(Toys.Pelvis)
		Debug.MessageBox("Success: Unequip pelvis")
	Else
		Debug.MessageBox("Fail: Unequip pelvis - see log")
	EndIf
EndFunction

;.......... GetToy() & HandleToy() - Random Equip from Insignia box
Function TStoryTest3()
	TStoryLog("TESTING GetToy() & HandleToy() Random Equip from Insignia box")
	Count = 0
	Total = Utility.RandomInt(3, 4)
	While Count < Total
		TStoryHandleToy(Toys.GetToy("TStory", ToyBox="Insignia"))
		Count += 1
	Endwhile
	Debug.MessageBox("Done: Random Equip from Insignia box... Gave preference to the Insignia box, equipping toys from only that box if possible, otherwise random selecting other boxes. It's done playing nice, not using slots if a toy from another mod is worn with a restrictive keyword.")
EndFunction

;.......... GetToy() & HandleToy() - Random Equip from ANY box
Function TStoryTest4()
	TStoryLog("TESTING GetToy() & HandleToy() Random Equip from ANY box")
	Count = 0
	Total = Utility.RandomInt(3, 4)
	While Count < Total
		TStoryHandleToy(Toys.GetToy("TStory"))
		Count += 1
	Endwhile
	Debug.MessageBox("Done: Random Equip from ANY box... Gave preference to the most commonly 'worn' box, equipping toys from only that box if possible, otherwise random selecting other boxes. It's done playing nice, not using slots if a toy from another mod is worn with a restrictive keyword.")
EndFunction

;.......... GetToy() - Random select toys from ANY box
Function TStoryTest8()
	TStoryLog("TESTING GetToy() & HandleToy() Random select toys from ANY box")
	Count = 0
	Total = Utility.RandomInt(3, 4)
	While Count < Total
		Toy = Toys.GetToy("TStory", Available=False)
		If Toy
			PlayerRef.AddItem(Toy, 1, True)
		EndIf
		Count += 1
	Endwhile
	Debug.MessageBox("Done: Random select toys from ANY box. Selected toys were placed in your inventory... Random selected a box, then gave preference to it, equipping toys from only that box if possible, otherwise random selecting other boxes. It's done playing nice, not using slots if a toy from another mod is worn with a restrictive keyword.")
EndFunction

;.......... ReserveSlots() - Reserve Slots
Function TStoryTest5()
	TStoryLog("TESTING ReserveSlots() Reserve Slots")
	If Toys.ReserveSlots("TStory")
		Debug.MessageBox("Success: Reserve Slots")
	Else
		Debug.MessageBox("Fail: Reserve Slots - see log")
	EndIf
EndFunction

;.......... ReserveSlots() - Un-Reserve Slots
Function TStoryTest6()
	TStoryLog("TESTING ReserveSlots() Un-Reserve Slots")
	If Toys.ReserveSlots("TStory", False)
		Debug.MessageBox("Success: Un-Reserve Slots")
	Else
		Debug.MessageBox("Fail: Un-Reserve Slots - see log")
	EndIf
EndFunction

;.......... IsSlotsReserved() - Are Slots Reserved?
Function TStoryTest7()
	TStoryLog("TESTING IsSlotsReserved() Are Slots Reserved?")
	If Toys.IsSlotsReserved("TStory")
		Debug.MessageBox("True: Slots are Reserved by another mod")
	Else
		Debug.MessageBox("False: Slots not Reserved by another mod")
	EndIf
EndFunction

;.......... UnequipToys() - Unequip All excelpt Pelvis & Destroy
Function TStoryTest9()
	TStoryLog("TESTING UnequipToys() Unequip All excelpt Pelvis & Destroy")
	If TStoryUnequipToys(Toys.ToysToy, Toys.Pelvis, Destroy=True)
		Debug.MessageBox("Success: Unequip All excelpt Pelvis & Destroy")
	Else
		Debug.MessageBox("Fail: Unequip All excelpt Pelvis & Destroy - see log")
	EndIf
EndFunction

;.......... UnequipToys() - Unequip All to Storage
Function TStoryTest10()
	TStoryLog("TESTING UnequipToys() Unequip All to Storage")
	If TStoryUnequipToys(Toys.ToysToy, Store=True)
		Debug.MessageBox("Success: Unequip All to Storage")
	Else
		Debug.MessageBox("Fail: Unequip All to Storage. Did you forget to Reserve Slots? - see log")
	EndIf
EndFunction

;.......... UnStoreToys() - Un-store
Function TStoryTest11()
	TStoryLog("TESTING UnStoreToys() Un-store")
	If TStoryUnStoreToys()
		Debug.MessageBox("Success: Un-store")
	Else
		Debug.MessageBox("Fail: Un-store - see log")
	EndIf
EndFunction

;.......... IsSlotAvailable() - Can Pelvis Slot be used?
Function TStoryTest12()
	TStoryLog("TESTING IsSlotAvailable() Can Pelvis Slot be used?")
	If TStorySlotAvailable(7)
		Debug.MessageBox("True: Pelvis Slot can be used")
	Else
		Debug.MessageBox("False: Pelvis Slot cannot be used - see log")
	EndIf
EndFunction

;.......... IsSlotAvailable() - Can Pelvis Slot be used by storing?
Function TStoryTest13()
	TStoryLog("TESTING IsSlotAvailable() Can Pelvis Slot be used by storing?")
	If TStorySlotAvailable(7, IfUseStore=True)
		Debug.MessageBox("True: Pelvis Slot can be used by storing")
	Else
		Debug.MessageBox("False: Pelvis Slot cannot be used by storing - see log")
	EndIf
EndFunction

;.......... HideToys() - Hide all toys inappropriate for animation scenes
Function TStoryTest14()
	TStoryLog("TESTING HideToys() Hide all toys inappropriate for animation scenes")
	TStoryHideToys()
	Debug.MessageBox("Done: Hide all toys inappropriate for animation scenes")
EndFunction

;.......... UnHideToys() - UnHide the hidden toys
Function TStoryTest15()
	TStoryLog("TESTING UnHideToys() UnHide the hidden toys")
	TStoryUnHideToys()
	Debug.MessageBox("Done: UnHide the hidden toys")
EndFunction

;========== Story Events ==========
;==================================

;.......... Trial 1 - Arousal
Function TStoryTrial1Activate()
	TStoryLog("Arousal Station Activated")
	If ! Trial1Before
		Toys.Lib.SLA.SetActorExposure(PlayerRef, 54)
	EndIf
	If ! ArousalUp
		ArousalUp = True
		TStoryNotify("You feel flushed")
	Else
		ArousalUp = False
		TStoryNotify("You feel calmed and normal again")
	EndIf
	Int Timer = Utility.RandomInt(8,14)
	While ArousalUp && StatueIsUp
		Count = 0
		Toys.ArousalAdjust(9, True)
		While Count < Timer && ArousalUp
			Count += 1
			Utility.WaitMenuMode(1)
		Endwhile
		If ! Trial1Before && Toys.Lib.SLA.GetActorArousal(PlayerRef) > 95
			Trial1Before = True
			ToyStory.SetObjectiveDisplayed(80)
			ToyStory.SetStage(80)
			ToyStory.SetObjectiveCompleted(80)
			Toys.SpontaneousOrgasm()
			Utility.WaitMenuMode(5)
		EndIf
	Endwhile
	While ! ArousalUp && StatueIsUp
		Count = 0
		Toys.ArousalAdjust(-9, True)
		While Count < Timer && ! ArousalUp
			Count += 1
			Utility.WaitMenuMode(1)
		Endwhile
	Endwhile
EndFunction

;.......... Standing Stone Rise/Sink
Function TStoryStandingStoneRise(Bool Sink=False)
	If StoneTransComplete && ! StoneIsUp && ! Sink
		StoneTransComplete = False
		StoneIsUp = True
		TStoryLog("Phasing Stone Rises")
		TStoryBeam(PhasingStone, 4)
		PhasingStone.KnockAreaEffect(1, 3000)
		Rocks.Play(PlayerRef)
		PhasingStone.TranslateTo(PhasingStone.GetPositionX(), PhasingStone.GetPositionY(), PhasingStone.GetPositionZ()+230, 0, 0, PhasingStone.GetAngleZ()+180, 20, 0.0)
		Game.ShakeCamera(PhasingStone, afStrength = 1, afDuration = 5)
		Toys.WaitForIt(Utility.RandomInt(3, 5))
		Rocks.Play(PlayerRef)
	ElseIf StoneTransComplete && StoneIsUp && Sink && ! Ported 
		StoneTransComplete = False
		StoneIsUp = False
		Rocks.Play(PlayerRef)
		PhasingStone.TranslateTo(PhasingStone.GetPositionX(), PhasingStone.GetPositionY(), PhasingStone.GetPositionZ()- 230, 0, 0, PhasingStone.GetAngleZ()- 180, 20, 0.0)
		Game.ShakeCamera(PhasingStone, afStrength = 1, afDuration = 5)
		Toys.WaitForIt(Utility.RandomInt(3, 5))
		Rocks.Play(PlayerRef)
	EndIf
EndFunction

;.......... Standing Stone
Function TStoryStandingStone(ObjectReference SStone)
	If Toys.IsBusy()
		TStoryNotify("Can't activate if busy or in combat")
		Return
	ElseIf ToyStory.GetStage() < 30 || ! StoneIsUp
		TStoryNotify("Phasing Stone ignores you")
		Return		
	ElseIf ! StoneTransComplete
		TStoryNotify("Can't activate while moving")
		Return
	EndIf
	Debug.Notification("Phasing Stone Love")
	TStoryLog("Phasing Stone Love")
	Utility.SetIniBool("bDisablePlayerCollision:Havok",true)
	Toys.InitSceneStart()
	ToysBlackFog.Cast(PlayerRef)
	TStoryStoreOnStone()
	;get relative to position
	Float Anglez = SStone.GetAngleZ()
	Float Anglex = SStone.GetAngleX() * -1
	Float TempFloat = 120 * math.cos(Anglex)  ;move forward
	Float Offsetx = TempFloat * math.sin(Anglez)
	Float Offsety = TempFloat * math.cos(Anglez)
	Float Posx = SStone.GetPositionX() + Offsetx
	Float Posy = SStone.GetPositionY() + Offsety
	Utility.Wait(0.2)
	Toys.AdjustHeight()
	Float Posz = PlayerRef.GetPositionZ()
	Utility.Wait(0.5)
	PlayerRef.TranslateTo(Posx, Posy, Posz, SStone.GetAngleX(), PlayerRef.GetAngleY(), SStone.GetAngleZ(), 50000, 0.0)
	PlayerRef.SetAngle(0.0, 0.0, SStone.GetAngleZ()+10)
	PlayerRef.TranslateTo(Posx, Posy, Posz, SStone.GetAngleX(), SStone.GetAngleY(), PlayerRef.GetAngleZ()+0.01, 500.0, 0.0001) 
	Debug.SendAnimationEvent(PlayerRef, "TStoryKom_Machine_A1_S1")
	SStone.playAnimation("playanim01")
	
	;StoneGirl setup
	Utility.Wait(0.5)
	StoneGirl.MoveTo(SStone)
	StoneGirl.Enable()
	StoneGirl.SetAlpha(0)
	ActorUtil.AddPackageOverride(StoneGirl, DoNothing, 100, 1)
	StoneGirl.EvaluatePackage()
	Utility.Wait(0.3)
	StoneGirl.TranslateTo(Posx, Posy, Posz, SStone.GetAngleX(), SStone.GetAngleY(), SStone.GetAngleZ(), 50000, 0.0)
	StoneGirl.SetAngle(0.0, 0.0, SStone.GetAngleZ()+10)
	StoneGirl.TranslateTo(Posx, Posy, Posz, SStone.GetAngleX(), SStone.GetAngleY(), StoneGirl.GetAngleZ()+0.01, 500.0, 0.0001) 
	Utility.Wait(0.2)
	Debug.SendAnimationEvent(StoneGirl, "TStoryKom_Machine_A2_S1")
	Debug.Notification("Phasing Stone phased some toys")
	TStoryDevTip("This scene uses Toys.IsBusy() and Toys.InitSceneStart()/end. For more info see in ToysFramework.psc")
	TStoryDevTip("DEMO 2. Hide toys during a love scene.")
	Toys.WaitForIt(3)
	StoneGirl.SetAlpha(1)
	Toys.WaitForIt(4)
	Toys.SayTopic(PhasingStoneTopic, 9)
	
	Count = 1
	While Count <= 7 && ! Toys.AdvanceKey && ! Sexlab.IsActorActive(PlayerRef)
		IF count > 2
			SStone.playAnimation("playanim01")
		EndIf
		If Utility.RandomInt(1, 2) == 1 && Count > 3
			Int Counter2 = 0
			Int Times2 = Utility.RandomInt(5, 8)
			Rocks.Play(PlayerRef)
			While Counter2 < Times2 && ! Toys.AdvanceKey
				SStone.TranslateTo(SStone.GetPositionX(), SStone.GetPositionY(), SStone.GetPositionZ(), SStone.GetAngleX(), SStone.GetAngleY(), SStone.GetAngleZ()+2, 300, 300.0)
				Utility.Wait(0.1)
				SStone.TranslateTo(SStone.GetPositionX(), SStone.GetPositionY(), SStone.GetPositionZ(), SStone.GetAngleX(), SStone.GetAngleY(), SStone.GetAngleZ() - 2, 300, 300.0)
				Counter2 += 1
				Utility.Wait(0.1)
			Endwhile
		EndIf
		If Utility.RandomInt(1, 3) != 1 || Count == 2
			Toys.SquirtingEffect()
		EndIf
		Toys.OrgasmSound()
		Int Anim = Utility.RandomInt(1, 7)
		If Anim == 1
			Debug.SendAnimationEvent(PlayerRef, "TStoryKom_Machine_A1_S2")
			Debug.SendAnimationEvent(StoneGirl, "TStoryKom_Machine_A2_S2")
		ElseIf Anim == 2
			Debug.SendAnimationEvent(PlayerRef, "TStoryKom_Machine_A1_S3")
			Debug.SendAnimationEvent(StoneGirl, "TStoryKom_Machine_A2_S3")
		ElseIf Anim == 3
			Debug.SendAnimationEvent(PlayerRef, "TStoryKom_Machine_A1_S4")
			Debug.SendAnimationEvent(StoneGirl, "TStoryKom_Machine_A2_S4")
		ElseIf Anim == 4
			Debug.SendAnimationEvent(PlayerRef, "TStoryKom_Machine_A1_S5")
			Debug.SendAnimationEvent(StoneGirl, "TStoryKom_Machine_A2_S5")
		ElseIf Anim == 5
			Debug.SendAnimationEvent(PlayerRef, "TStoryKom_Machine_A1_S6")
			Debug.SendAnimationEvent(StoneGirl, "TStoryKom_Machine_A2_S6")
		ElseIf Anim == 6
			Debug.SendAnimationEvent(PlayerRef, "TStoryKom_Machine_A1_S7")
			Debug.SendAnimationEvent(StoneGirl, "TStoryKom_Machine_A2_S7")
		Else
			Debug.SendAnimationEvent(PlayerRef, "TStoryKom_Machine_A1_S8")
			Debug.SendAnimationEvent(StoneGirl, "TStoryKom_Machine_A2_S8")
		EndIf
		Toys.WaitForIt(Utility.RandomInt(7, 10))	
		PlayerRef.TranslateTo(Posx, Posy, Posz, SStone.GetAngleX(), PlayerRef.GetAngleY(), SStone.GetAngleZ(), 50000, 0.0)
		PlayerRef.SetAngle(0.0, 0.0, SStone.GetAngleZ()+10)	
		PlayerRef.TranslateTo(Posx, Posy, Posz, SStone.GetAngleX(), SStone.GetAngleY(), PlayerRef.GetAngleZ()+0.01, 500.0, 0.0001)
		If Count == 2
			Toys.SayTopic(PhasingStoneTopic2, 9)
			Utility.WaitMenuMode(0.1)
			Toys.FreeCamStart()
		EndIf
		Count += 1
	Endwhile
	If ToyStory.GetStage() == 30
		ToyStory.SetObjectiveCompleted(30)
		ToyStory.SetStage(50)
	EndIf

	;final anim
	Debug.SendAnimationEvent(PlayerRef, "TStoryKom_Machine_A1_S9")
	Debug.SendAnimationEvent(StoneGirl, "TStoryKom_Machine_A2_S9")
	Toys.WaitForIt(18)
	StoneGirl.Disable()

	;portal to location that shall not be named
	Ported = True
	TStoryPortEffect1()
	Toys.FreeCamEnd()
	Toys.InitSceneEnd()
	Utility.SetIniBool("bDisablePlayerCollision:Havok",false)
	Toys.ResetHeight()
	Toys.FixIdle()
	PlayerRef.MoveTo(NotNamedMarker)
	TStoryPortEffect2()
	TStoryLog("Ported to location that shall not be named")
	If ToyStory.GetStage() == 50
		ToyStory.SetObjectiveCompleted(40)
		ToyStory.SetObjectiveDisplayed(50)
	EndIf
	Utility.Wait(0.1)
	TStoryUnHideToys()
EndFunction

;.......... Nocturnal Entry Statue
Function TStoryStatue1Aware()
	If ! Statue1DoneOnce
		TStoryStatueTransform(EntryStatue, EntryStatueSexy)
		Statue1DoneOnce = True
	EndIf
EndFunction
Function TStoryStatue1Activate()
	If ! StatueTransComplete || ! StatueTransComplete2
		TStoryNotify("Cannot use while moving")
		Return
	ElseIf ToyStory.GetStage() == 50
		ToyStory.SetObjectiveCompleted(50)
		ToyStory.SetStage(60)
		ToyStory.SetObjectiveDisplayed(60)
	EndIf
	TStoryStatueRise(EntryStatueSexy)
EndFunction

;.......... Nightly First Meeting
Function TStoryMeetNightly()
	If ToyStory.GetStage() == 60
		PlayerRef.SetRestrained(True)
		TStorySummonNightly(NightlyMeetSpot)
		Utility.Wait(1)
		Nightly.KnockAreaEffect(1, 3000)
		TStoryEquipNightly()
		PlayerRef.SetRestrained(False)
	ElseIf PauseCurioStart
		PauseCurioStart = False
	EndIf
EndFunction
Function TStoryMeetNightly2()
	ToyStory.SetStage(70)
	ToyStory.SetObjectiveCompleted(60)
	ToyStory.SetObjectiveDisplayed(70)
	Nightly.KnockAreaEffect(1, 3000)
	TStoryUnStoreCurio()
EndFunction
Function TStoryMeetNightly3()
	Nightly.KnockAreaEffect(0.6, 3000)
	Toys.WuusshEffect(PlayerRef)
	TStoryHandleToy(NippleT)
	TStoryNotify("Nightly's Nipple Ts equipped")
EndFunction
Function TStoryTrial1()
	TStoryNightlyLeave()
	If ToyStory.GetStage() == 70
		ToyStory.SetStage(75)
	EndIf
EndFunction
Function TStoryChamberCenter()
	If ToyStory.GetStage() == 80
		TStorySummonNightly()
	ElseIf TalosCurse.GetStage() == 10 || (Curio.GetStage() == 10 && ! PauseCurioStart)
		TStoryMeetNightlyVarious()
	EndIf
EndFunction
Function TStoryMeetNightly4()
	Curio.Start()
	Curio.SetActive()
	Curio.SetObjectiveDisplayed(10)
	PauseCurioStart = True
EndFunction
Function TStoryMeetNightly5()
	ToyStory.SetStage(90)
	ToyStory.SetObjectiveDisplayed(90)
	StorageChest.Lock(False)
	Utility.Wait(2)
	TStoryNightlyLeave()
EndFunction
Function TStoryMeetNightly6()
	TStoryNotify("Items returned")
	ToyStory.SetObjectiveCompleted(90)
	Utility.WaitMenuMode(2)
	Input.TapKey(1)
	TStoryPortEffect1()
	TStoryReserveSlots(False)
	TStoryHandleToy(NippleT)
	PlayerRef.MoveTo(PhasingStonePortSpot)
	TStoryPortEffect2()
	TStoryLog("Ported out of location that shall not be named")
	ToyStory.SetStage(100)
EndFunction

;.......... Entry Statue Transform
;happens only first time you encounter the entry statue
Function TStoryStatueTransform(ObjectReference Origin, ObjectReference Sexy)
	StatueTransComplete2 = False
	TStoryBeam(Origin, 2)
	ToysBlackFog.Cast(PlayerRef)
	Origin.KnockAreaEffect(1, 3000)
	Origin.DisableNoWait()
	Sexy.EnableNoWait()
	Utility.Wait(2)
	TStoryStatueShake(Sexy)
	Origin.EnableNoWait()
	Sexy.DisableNoWait()
	TStoryStatueShake(Origin)
	Utility.Wait(2)
	Origin.DisableNoWait()
	Sexy.EnableNoWait()
	Utility.Wait(2)
	TStoryStatueShake(Sexy)
	Origin.EnableNoWait()
	Sexy.DisableNoWait()
	TStoryStatueShake(Origin)
	Utility.Wait(2)
	Origin.DisableNoWait()
	Sexy.EnableNoWait()
	TStoryStatueShake(Sexy)
	StatueTransComplete2 = True
EndFunction
Function TStoryStatueShake(ObjectReference Statue)
	If Statue.Is3DLoaded()
		Statue.TranslateTo(Statue.GetPositionX(), Statue.GetPositionY(), Statue.GetPositionZ(), 0, 0, Statue.GetAngleZ() + 7, 300, 300.0)
		Utility.Wait(0.1)
		Statue.TranslateTo(Statue.GetPositionX(), Statue.GetPositionY(), Statue.GetPositionZ(), 0, 0, Statue.GetAngleZ() - 7, 300, 300.0)
		Statue.TranslateTo(Statue.GetPositionX(), Statue.GetPositionY(), Statue.GetPositionZ(), 0, 0, Statue.GetAngleZ() + 7, 300, 300.0)
		Utility.Wait(0.1)
		Statue.TranslateTo(Statue.GetPositionX(), Statue.GetPositionY(), Statue.GetPositionZ(), 0, 0, Statue.GetAngleZ() - 7, 300, 300.0)
		Utility.Wait(0.3)
		Statue.StopTranslation()
	EndIf
EndFunction

;.......... Entry Statue Up/Down
Function TStoryStatueRise(ObjectReference Statue)
	If StatueTransComplete && ! Statue1IsUp
		StatueTransComplete = False
		Statue1IsUp = True
		EntryStatueLever.Enable()
		Statue.Enable()
		Utility.Wait(0.2)
		TStoryLog("Statue1 Rises")
		TStoryBeam(Statue, 4)
		Rocks.Play(PlayerRef)
		Statue.TranslateTo(Statue.GetPositionX(), Statue.GetPositionY(), Statue.GetPositionZ()+260, 0, 0, Statue.GetAngleZ()+180, 25, 0.0)
		Game.ShakeCamera(Statue, afStrength = 1, afDuration = 5)
		Utility.Wait(3)
		Rocks.Play(PlayerRef)
	ElseIf StatueTransComplete && Statue1IsUp
		StatueTransComplete = False
		Statue1IsUp = False
		Statue.KnockAreaEffect(1, 3000)
		Utility.Wait(3)
		Rocks.Play(PlayerRef)
		Statue.TranslateTo(Statue.GetPositionX(), Statue.GetPositionY(), Statue.GetPositionZ() - 260, 0, 0, Statue.GetAngleZ()- 180, 25, 0.0)
		Game.ShakeCamera(Statue, afStrength = 1, afDuration = 5)
		Utility.Wait(3)
		TStoryStoreOnEntry()
		Rocks.Play(PlayerRef)
		While ! StatueTransComplete
			Utility.Wait(1)
		Endwhile
		EntryStatueLever.Disable()
		Statue.Disable()
	EndIf
EndFunction

;.......... Statue Up/Down
Function TStoryStatueUpDown(ObjectReference Statue, ObjectReference NightlySpot=none, Bool GoDown)
	If StatueTransComplete && ! StatueIsUp && ! GoDown
		StatueTransComplete = False
		StatueIsUp = True
		TStoryLog("Statue Rises for Trial")
		PlayerRef.SetRestrained(True)
		TStoryBeam(Statue, 4)
		Rocks.Play(PlayerRef)
		Statue.TranslateTo(Statue.GetPositionX(), Statue.GetPositionY(), Statue.GetPositionZ()+260, 0, 0, Statue.GetAngleZ()+180, 25, 0.0)
		Game.ShakeCamera(Statue, afStrength = 1, afDuration = 5)
		Utility.WaitMenuMode(3)
		PlayerRef.SetRestrained(False)
		Rocks.Play(PlayerRef)
		Utility.WaitMenuMode(1)
		TStorySummonNightly(NightlySpot)
		ToyStory.SetObjectiveCompleted(70)
	ElseIf StatueTransComplete && StatueIsUp && GoDown
		StatueTransComplete = False
		StatueIsUp = False
		Statue.KnockAreaEffect(1, 3000)
		Rocks.Play(PlayerRef)
		Statue.TranslateTo(Statue.GetPositionX(), Statue.GetPositionY(), Statue.GetPositionZ() - 260, 0, 0, Statue.GetAngleZ()- 180, 25, 0.0)
		Game.ShakeCamera(Statue, afStrength = 1, afDuration = 5)
		Utility.WaitMenuMode(3)
		Rocks.Play(PlayerRef)
	EndIf
EndFunction

;.......... Nightly Meeting for Various
Function TStoryMeetNightlyVarious()
	PlayerRef.SetRestrained(True)
	TStorySummonNightly(CenterMeetSpot)
	Utility.Wait(1)
	Nightly.KnockAreaEffect(1, 3000)
	Utility.Wait(2)
	PlayerRef.SetRestrained(False)
EndFunction

;.......... Curse of Talos - Equip Random Toy
Event OnGainLOS(Actor TalosPriest, ObjectReference PlayerRef)
	If Utility.RandomInt(0, 100) <= MCM.TStoryRandomToyChance && MQ104.GetStage() > 90 && ToyStory.IsCompleted() && ! PlayerRef.IsSneaking()
		Toy = Toys.GetToy("TStory",Prefer=MCM.TStoryPreference)
		If Toy
			TStoryHandleToy(Toy)
			TStoryNotify("Curse of Talos equipped " + Toy.GetName())
			Toys.Lib.TransformSound.Play(PlayerRef)
			TStoryLog("Curse of Talos toy equipped")
		EndIf
		If ! TalosCurseStarted
			TalosCurseStarted = True
			TalosCurse.Start()
			TalosCurse.SetActive()
			TalosCurse.SetObjectiveDisplayed(10)
			TStoryTip("A toy appeared on me. I don't know why. (see Quest Journal)")
			TStoryLog("Curse of Talos quest triggered")
		EndIf
	EndIf
EndEvent

;.......... Nightly End Meeting for Talos Curse
Function TStoryTalosMeetNightly2()
	TalosCurse.SetStage(20)
	TalosCurse.SetObjectiveCompleted(10)
EndFunction

;.......... Curios Curio
Function TStoryCuriosCurio1()
	Curio.SetStage(20)
	Curio.SetObjectiveCompleted(10)
	Curio.SetObjectiveDisplayed(20)
EndFunction
Function TStoryCuriosCurio2()
	TStoryTip("Toy Story is in beta. This quest is a WIP. You've reached the end of what's ready to release. Much more is coming.")
	Curio.SetStage(30)
	Curio.SetObjectiveCompleted(20)
EndFunction

;.......... Feet Loving
Function TStoryFeetLove(Actor NPC)
	Utility.SetIniBool("bDisablePlayerCollision:Havok",true)
	Toys.InitSceneStart()
	Toys.HideToys("TStory", True, False, True, False, False, False)
	Toys.AdjustHeight()
	Float Posx = NPC.GetPositionX()
	Float Posy = NPC.GetPositionY()
	Float Posz = NPC.GetPositionZ()
	If ! Toys.AdvanceKey
		NPC.SetRestrained(True)
		ActorUtil.AddPackageOverride(NPC, DoNothing, 100, 1)
		NPC.EvaluatePackage()
		StrippedItems = SexLab.ActorLib.StripActor(NPC, DoAnimate= false)
		PlayerRef.MoveTo(NPC)
		Utility.WaitMenuMode(0.5)
		PlayerRef.TranslateTo(Posx, Posy, Posz, 0, 0, NPC.GetAngleZ(), 50000, 0.0)
		;Utility.WaitMenuMode(0.1)
		;PlayerRef.SetRestrained(False)
		Toys.FreeCamStart()
		Utility.WaitMenuMode(0.1)
		;entry anim
		Debug.SendAnimationEvent(PlayerRef, "Leito_Feet_A1_S1")
		Debug.SendAnimationEvent(NPC, "Leito_Feet_A2_S1")
		Utility.WaitMenuMode(0.1)
		PlayerRef.TranslateTo(PlayerRef.GetPositionX(), PlayerRef.GetPositionY(), PlayerRef.GetPositionZ(), PlayerRef.GetAngleX(), PlayerRef.GetAngleY(), PlayerRef.GetAngleZ()+0.01, 500.0, 0.0001)
		NPC.TranslateTo(NPC.GetPositionX(), NPC.GetPositionY(), NPC.GetPositionZ(), NPC.GetAngleX(), NPC.GetAngleY(), NPC.GetAngleZ()+0.01, 500.0, 0.0001)
		Toys.WaitForIt(1)
	EndIf
	;additional anim
	Count = 1
	While Count <= 4 && ! Toys.AdvanceKey && ! Sexlab.IsActorActive(PlayerRef)

		If Count == 1
			Debug.SendAnimationEvent(PlayerRef, "Leito_Feet_A1_S2")
			Debug.SendAnimationEvent(NPC, "Leito_Feet_A2_S2")
		ElseIF Count == 2
			Debug.SendAnimationEvent(PlayerRef, "Leito_Feet_A1_S3")
			Debug.SendAnimationEvent(NPC, "Leito_Feet_A2_S3")
		ElseIF Count == 3
			Debug.SendAnimationEvent(PlayerRef, "Leito_Feet_A1_S4")
			Debug.SendAnimationEvent(NPC, "Leito_Feet_A2_S4")
		ElseIF Count == 4
			Debug.SendAnimationEvent(PlayerRef, "Leito_Feet_A1_S5")
			Debug.SendAnimationEvent(NPC, "Leito_Feet_A2_S5")
		EndIf

		Toys.PantSound()
		;Int Random = Utility.RandomInt(1, 3)
		;If Random == 1
		;	VirginSlapSound()
		;ElseIf Random == 2
		;	VirginSpankSound()
		;EndIf
		;PlayerRef.TranslateTo(Posx, Posy, Posz, 0, 0, NPC.GetAngleZ(), 50000, 0.0)
		;PlayerRef.TranslateTo(PlayerRef.GetPositionX(), PlayerRef.GetPositionY(), PlayerRef.GetPositionZ(), PlayerRef.GetAngleX(), PlayerRef.GetAngleY(), PlayerRef.GetAngleZ()+0.01, 500.0, 0.0001)
		;Utility.WaitMenuMode(0.1)
		Count = Count + 1
	EndWhile
	;end
	Debug.SendAnimationEvent(NPC, "IdleForceDefaultState")
	ActorUtil.RemoveAllPackageOverride(DoNothing)
	NPC.EvaluatePackage()
	SexLab.ActorLib.UnstripActor(NPC, StrippedItems)
	Toys.FreeCamEnd()
	Toys.UnHideToys("TStory")
	Toys.InitSceneEnd()
	Utility.SetIniBool("bDisablePlayerCollision:Havok",false)
	Toys.ResetHeight()
	Toys.FixIdle()
	PlayerRef.StopTranslation()
	NPC.StopTranslation()
EndFunction

;========== Utility ==========
;=============================

;.......... Write to Log
Function TStoryLog(String Log, Bool Critical=False)
	If MCM.TStoryVerboseLog && ! Critical
		Debug.Trace("[TStory] " + Log)
	EndIf
	If Critical
		Debug.Trace("[*TStory] " + Log)
	EndIf
EndFunction

;.......... Tip Message Box
;display Tip only if its the first time, and Tips are enabled in MCM
Function TStoryTip(String Text)
	If MCM.TStoryTips
		Utility.WaitMenuMode(0.5)
		Debug.MessageBox("Toy Story Tip: " + Text)
	EndIf
EndFunction

;.......... Dev Tip Message Box
;display Dev Tip only if Dev Tips are enabled in MCM
Function TStoryDevTip(String Text)
	If MCM.TStoryDevTips
		Utility.WaitMenuMode(0.5)
		Debug.MessageBox("Toy Story DEV Tip: " + Text)
	EndIf
EndFunction

;.......... Notifications
Function TStoryNotify(String Msg, Int Category=0)
	;If Category == 0 || (Category == 1 && MCM.ToysArousalNotify) || (Category == 2 && MCM.ToysEffectNotify) || (Category == 3 && MCM.ToysProtectNotify) 
		Debug.Notification(Msg)
	;EndIf
EndFunction

;.......... Game Start & Periodic Check
Event OnUpdateGameTime()
	;Delay after a game start/load save
	If PeriodicFirstCount < 3  ;delay first 3
		PeriodicFirstCount += 1
		If PeriodicFirstCount >= 3
			RegisterForSingleUpdateGameTime(0.25)  ;set to normal
		Else
			RegisterForSingleUpdateGameTime(0.03)
			Return
		EndIf
	EndIf
	;initialization each time game is loaded
	If DelayedLoadInit && ! UI.IsMenuOpen("Dialogue Menu") && ! (MQ101.GetStage() > 0 && MQ101.GetStage() < 200)
		RegisterForLOS(Heimskr, PlayerRef)
		RegisterForLOS(Lortheim, PlayerRef)
		RegisterForLOS(Nura, PlayerRef)
		Toys.AdvanceKey = False
		TStorySetHotKey()
		DelayedLoadInit = False
		If ! ToyStory.IsRunning()
			TStoryLog("A Toy Story (quest) STARTED")
			ToyStory.Start()
			ToyStory.SetObjectiveDisplayed(10)
			ToyStory.SetActive()
		EndIf
		StoneTransComplete = True
		If ! MCM.TStoryToysVersionCorrect()
			Debug.MessageBox("Toy Story, Critical Error: Incorrect version of Toys is installed.")
		EndIf
	EndIf
	;.......... Periodic Checks (per quarter game hour)
	;future stuff
EndEvent

;.......... Beam of Light Canceller
Event OnUpdate()
	TStoryBeamRemove()
EndEvent

;.......... Sexlab Scene Ended
Event LovingDone(string eventName, string argString, float argNum, form sender)

EndEvent

;.......... Hot Key Press & Release
Event OnKeyDown(Int KeyCode)
	;If KeyCode == 69 ;used for testing
	;	PlayerRef.PlaceAtMe(OversexedVisual)
	;	TStoryFeetLove(Nelacar)
	;EndIf
EndEvent

Function TStorySetHotKey()
	;UnregisterForAllKeys()
	;RegisterForKey(69) ;used for testing
EndFunction

;.......... Strip 
Function TStorysStrip()
	Armor BodyItem = PlayerRef.GetWornForm(0x00000004) as Armor
	If BodyItem && ! BodyItem.haskeyword(SexlabNoStrip)
		TStoryNotify("Your armor is forced off")
		Toys.WuusshEffect(PlayerRef)
		PlayerRef.UnequipItem(BodyItem, False, True)
	Else
		Toys.WuusshEffect(PlayerRef)
	EndIf
EndFunction

;.......... Nightly appears at player
Function TStorySummonNightly(ObjectReference Spot=none)
	SummonActive = True
	If Spot
		Nightly.MoveTo(Spot)
	Else
		Nightly.MoveTo(PlayerRef)
	EndIf
	If Nightly.IsDisabled()
		Debug.Notification("Nightly stumbles out of the shadows!")
		Utility.WaitMenuMode(0.2)
		Nightly.Enable()
		TStoryBeam(Nightly, 3)
		Ravens.Cast(PlayerRef)
		If PlayerRef.IsInCombat()
			Summon2.Cast(PlayerRef)
		Else
			Summon.Cast(PlayerRef)
		EndIf
	ElseIf PlayerRef.GetDistance(Nightly) > 800
		Nightly.MoveTo(PlayerRef)
	EndIf
	SummonActive = False
EndFunction
Function TStorySetGhost(ObjectReference Ghost)
	Actor Ghost1
	Ghost1 = Ghost as Actor
	Ghost1.SetAlpha(1)
EndFunction
Function TStoryPersonFade(ObjectReference Person)
	Actor Person1 = Person as Actor
	Count = 0
	Total = Utility.RandomInt(2, 5)
	While Count < Total && ! Person1.IsDisabled()
		Person1.SetAlpha(0.2, True)
		Utility.WaitMenuMode(Utility.RandomInt(2, 4))
		If ! Person1.IsDisabled()
			Person1.SetAlpha(1, True)
			Utility.WaitMenuMode(Utility.RandomInt(5, 9))
		EndIf
		Count += 1
	Endwhile
EndFunction
Function TStoryNightlyLeave()
	If Nightly
		TStoryBeam(Nightly, 2)
		TStoryEquipNightly()
		Utility.Wait(0.2)
		Nightly.SetAlpha(0)
		Nightly.Disable()
	EndIf
EndFunction

;.......... Portal Effect Start / End
Function TStoryPortEffect1()
	Toys.SetBusy() ;so we can't trigger something like Spontaneous Orgasm while porting
	PlayerRef.SetAlpha(0)
	TeleportFX.Play(PlayerRef)
	Lightning.Play(PlayerRef)
	Utility.Wait(0.3)
	Lightning.Play(PlayerRef)
	Utility.Wait(1.7)
	Lightning.Play(PlayerRef)
	Utility.Wait(0.3)
EndFunction
Function TStoryPortEffect2()
	Utility.Wait(0.5)
	Lightning.Play(PlayerRef)
	Utility.Wait(0.3)
	Lightning.Play(PlayerRef)
	Utility.Wait(0.7)
	TeleportFX.Stop(PlayerRef)
	PlayerRef.SetAlpha(1)
	Toys.SetBusy(False)
EndFunction

;.......... Black screen fade out
Function TStoryFadeout(Int Len)
	VC01BlackoutIMod.applyCrossFade(2.0)
	Toys.WaitForIt(Len)
EndFunction

;.......... Beam of Light
Function TStoryBeam(ObjectReference Place, Int Time)
	RegisterForSingleUpdate(Time)
	TStoryBeamRemove() ;removes previous beam
	BeamPlaced = Place.PlaceAtMe(LightBeam.GetBaseObject())
	If BeamPlaced
		BeamPlaced.EnableNoWait(True)
	EndIf
EndFunction
Function TStoryBeamRemove()
	If BeamPlaced
		BeamPlaced.Disable(True)
		If BeamPlaced
			BeamPlaced.Delete()
		EndIf
		BeamPlaced = none
	EndIf
EndFunction

;.......... Mod Events
Function TStoryRegModEvents()
	RegisterForModEvent("ToysSceneStart", "SceneStart")
	RegisterForModEvent("ToysSceneEnd", "SceneEnd")
	RegisterForModEvent("ToysSponOrgasm", "SponOrgasm")
	RegisterForModEvent("ToysExhausted", "Exhausted")
	RegisterForModEvent("ToysBlindFall", "BlindFall")
	RegisterForModEvent("ToysClimax", "Climax")
	RegisterForModEvent("ToysVaginalPenetration", "VaginalPenetration")	

	RegisterForModEvent("ToysArousalIncrease", "ArousalIncrease")
	RegisterForModEvent("ToysSquirt", "Squirt")
	RegisterForModEvent("ToysFondle", "Fondle")
	RegisterForModEvent("ToysSigning", "Signing")
	RegisterForModEvent("ToysBlindStumble", "BlindStumble")
	RegisterForModEvent("ToysDropKey", "DropKey")

	RegisterForModEvent("ToysStrip", "Strip")
	RegisterForModEvent("ToysBlindStart", "BlindStart")
	RegisterForModEvent("ToysBlindEnd", "BlindEnd")
	RegisterForModEvent("ToysCrawlStart", "CrawlStart")
	RegisterForModEvent("ToysCrawlEnd", "CrawlEnd")
	RegisterForModEvent("ToysArmBindStart", "ArmBindStart")
	RegisterForModEvent("ToysYokeBindStart", "YokeBindStart")
	RegisterForModEvent("ToysBindEnd", "BindEnd")
	RegisterForModEvent("ToysHarmHealth", "HarmHealth")
	RegisterForModEvent("ToysHarmStamina", "HarmStamina")
	
	RegisterForModEvent("ToysTransform", "Transform")
	RegisterForModEvent("ToysOrgasmFallOff", "OrgasmFallOff")
	RegisterForModEvent("ToysHitFallOff", "HitFallOff")
EndFunction
Function TStoryUnRegModEvents()
	UnregisterForModEvent("ToysSceneStart")
	UnregisterForModEvent("ToysSceneEnd")
	UnregisterForModEvent("ToysSponOrgasm")
	UnregisterForModEvent("ToysExhausted")
	UnregisterForModEvent("ToysBlindFall")
	UnregisterForModEvent("ToysClimax")
	UnregisterForModEvent("ToysVaginalPenetration")

	UnregisterForModEvent("ToysArousalIncrease")
	UnregisterForModEvent("ToysSquirt")
	UnregisterForModEvent("ToysFondle")
	UnregisterForModEvent("ToysSigning")
	UnregisterForModEvent("ToysBlindStumble")
	UnregisterForModEvent("ToysDropKey")

	UnregisterForModEvent("ToysStrip")
	UnregisterForModEvent("ToysBlindStart")
	UnregisterForModEvent("ToysBlindEnd")
	UnregisterForModEvent("ToysCrawlStart")
	UnregisterForModEvent("ToysCrawlEnd")
	UnregisterForModEvent("ToysArmBindStart")
	UnregisterForModEvent("ToysYokeBindStart")
	UnregisterForModEvent("ToysBindEnd")
	UnregisterForModEvent("ToysHarmHealth")
	UnregisterForModEvent("ToysHarmStamina")
	
	UnregisterForModEvent("ToysTransform")
	UnregisterForModEvent("ToysOrgasmFallOff")
	UnregisterForModEvent("ToysHitFallOff")
EndFunction
Event SceneStart(string eventName, string SceneName, float numArg, Form sender)
	TStoryNotify("Mod Event: " + SceneName + " SceneStart")
EndEvent
Event SceneEnd(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: SceneEnd")
EndEvent
Event SponOrgasm(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: SponOrgasm")
EndEvent
Event Exhausted(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: Exhausted")
EndEvent
Event BlindFall(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: BlindFall")
EndEvent
Event Climax(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: Climax")
EndEvent
Event VaginalPenetration(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: VaginalPenetration")
EndEvent
Event ArousalIncrease(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: ArousalIncrease")
EndEvent
Event Squirt(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: Squirt")
EndEvent
Event Fondle(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: Fondle")
EndEvent
Event Signing(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: Signing")
EndEvent
Event BlindStumble(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: BlindStumble")
EndEvent
Event DropKey(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: DropKey")
EndEvent
Event Strip(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: Strip")
EndEvent
Event BlindStart(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: BlindStart")
EndEvent
Event BlindEnd(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: BlindEnd")
EndEvent
Event CrawlStart(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: CrawlStart")
EndEvent
Event CrawlEnd(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: CrawlEnd")
EndEvent
Event ArmBindStart(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: ArmBindStart")
EndEvent
Event YokeBindStart(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: YokeBindStart")
EndEvent
Event BindEnd(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: BindEnd")
EndEvent
Event HarmHealth(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: HarmHealth")
EndEvent
Event HarmStamina(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: HarmStamina")
EndEvent
Event Transform(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: Transform")
EndEvent
Event OrgasmFallOff(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: OrgasmFallOff")
EndEvent
Event HitFallOff(string eventName, string strArg, float numArg, Form sender)
	TStoryNotify("Mod Event: HitFallOff")
EndEvent

;==========  Properties ==========
;=================================
TStoryMCM Property MCM Auto
sexlabframework Property SexLab Auto

Quest Property MQ101 Auto
Quest Property MQ104 Auto
Quest Property ToyStory Auto
Quest Property Curio Auto
Quest Property TalosCurse Auto

Actor Property PlayerRef Auto
Actor Property Nightly Auto
Actor Property StoneGirl Auto
Actor Property Heimskr Auto
Actor Property Lortheim Auto
Actor Property Nura Auto
Actor Property Nelacar Auto

Armor Toy

Package Property DoNothing Auto
;GlobalVariable Property TStoryBusy Auto ;1 = is busy in a scene ;using Toys? (remove in ck)
Keyword Property SexlabNoStrip Auto
Location Property NotBeNamed Auto

Spell Property Ravens Auto
Spell Property Summon Auto
Spell Property Summon2 Auto
Spell Property ToysBlackFog Auto

EffectShader property TeleportFX auto
ImageSpaceModifier Property VC01BlackoutIMod  Auto

ObjectReference Property NotNamedMarker Auto
ObjectReference Property PhasingStonePortSpot Auto
ObjectReference Property PhasingStone Auto
ObjectReference Property LightBeam Auto
ObjectReference Property SexyStatue Auto
ObjectReference Property EntryStatue Auto
ObjectReference Property EntryStatueSexy Auto
ObjectReference Property EntryStatueLever Auto
ObjectReference Property NightlyMeetSpot Auto
ObjectReference Property CenterMeetSpot Auto
ObjectReference Property StorageChest Auto
ObjectReference BeamPlaced

Topic Property PhasingStoneTopic Auto
Topic Property PhasingStoneTopic2 Auto

Sound Property Rocks Auto
Sound Property Lightning Auto

Int Property PeriodicFirstCount = 0 Auto
Int Property TStoryCurrentTrial Auto Conditional
Int	Count
Int	Total

Bool Property DelayedInit = True Auto
Bool Property DelayedLoadInit = True Auto
Bool Property SummonActive = False Auto
Bool Property StoneTransComplete = True Auto
Bool Property StatueTransComplete = True Auto
Bool Property Ported Auto
Bool StatueTransComplete2
Bool StoneIsUp
Bool Statue1IsUp = True
Bool StatueIsUp
Bool Statue1DoneOnce
Bool ArousalUp
Bool Trial1Before
Bool TalosCurseStarted
Bool PauseCurioStart

Form[] StrippedItems
